const chalk = require('chalk');
const prettyjson = require('prettyjson');
let cl = console.log.bind(console);

function tpl(str, ...names) {
    let symbols = names.map(s=>`#${s}`);
    let regexp = new RegExp(symbols.join('|'),'g');
    return function (...args) {
        let map = {};
        for (let i = 0; i < args.length; i++) {
            map[symbols[i]] = args[i];
        }
        return str.replace(regexp, (match) => {
            return map[match];
        });
    }
};
let style = {
    reportTitle: chalk.bgGreen.yellow.bold,
    report: chalk.green.italic,
    appSign: chalk.bold.underline.blue,
    commandLabel: chalk.bgMagenta.cyan.underline,
    readme: chalk.yellow.italic,
    errorText: chalk.red.dim,
    errorTitle: chalk.red.bold.underline,
    errorTitleDecor: chalk.red.bold,


    log: console.log.bind(console),
    errorTitle(title, text) {
        return ;
    },
    errorText: chalk.red.dim,
    error(title, text) {
        if (title instanceof Error) {
            this.error(title.message, title.stack);
        } else {
            return `${chalk.red.bold.underline(`!!! <[ Error: ${title} ]>`)}\n${this.errorText(`   ` +text.replace(/\n/g, `\n   `))}`;
        }
    },
    superStrong: chalk.inverse
};
let txt = {
    error: tpl("!!! <[ Error: #errorTitle ]>\n#errorText", 'errorTitle', 'errorText')
};

module.exports = Object.assign(cl, style, {txt}, {tpl});
